# -*- coding: utf-8 -*-
"""
/***************************************************************************
 utils
                                 A QGIS plugin
Search OpenStreetMap data by name or address using Nominating service
                             -------------------
        begin                : 2013-03-29
        copyright            : (C) 2013 by Piotr Pociask
        email                : piotr.pociask (at) gis-support (dot) pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 This script initializes the plugin, making it known to QGIS.
"""
from PyQt4.QtGui import QLineEdit, QToolButton, QStyle, QIcon
from PyQt4.QtCore import Qt, SIGNAL, QString, QObject, QFileInfo

class QgsFilterLineEdit(QLineEdit):
    def __init__(self, parent=None):
        pluginPath = QFileInfo(__file__).absolutePath()
        QLineEdit.__init__(self, parent)
        self.btnClear = QToolButton(self)
        self.btnClear.setIcon(QIcon(pluginPath + '/mIconClear.png'))
        self.btnClear.setCursor(Qt.ArrowCursor)
        self.btnClear.setStyleSheet("QToolButton{border:none;padding:0px}")
        self.btnClear.hide()
        
        QObject.connect(self.btnClear, SIGNAL("clicked()"), self.clear)
        QObject.connect(self, SIGNAL("textChanged(QString)"), self.toggleClearButton)
        
        self.frameWidth = self.style().pixelMetric(QStyle.PM_DefaultFrameWidth)
        self.setStyleSheet(QString("QLineEdit{padding-right:%1px}").arg(self.btnClear.sizeHint().width()+self.frameWidth+1))
        
        self.msz = self.minimumSizeHint()
        self.setMinimumSize(max(self.msz.width(), self.btnClear.sizeHint().height()+self.frameWidth*2+2),
                            max(self.msz.height(), self.btnClear.sizeHint().height()+self.frameWidth*2+2))
        
    def resizeEvent(self, event):
        self.sz = self.btnClear.sizeHint()
        self.frameWidth = self.style().pixelMetric(QStyle.PM_DefaultFrameWidth)
        self.btnClear.move(self.rect().right()-self.frameWidth-self.sz.width(),
                           (self.rect().bottom()+1 - self.sz.height())/2)
    
    def toggleClearButton(self, text):
        self.btnClear.setVisible(not text.isEmpty())